import { GraphQLClient } from 'graphql-request';

//const gql = new GraphQLClient('/graphql', {headers: {Authorization: 'Bearer ' + ... }})
const gql = new GraphQLClient('/graphql')

export const actionSearch = text => ({type: 'SEARCH', text})
export const actionSearchResult = payload => ({type: 'SEARCH_RESULT', payload})

export const actionPromise = (name, promise) => {
    const actionPending = () => ({type: 'PROMISE', name, status: 'PENDING', payload: null, error: null})
    const actionResolved = payload => ({type: 'PROMISE', name, status: 'RESOLVED', payload, error: null})
    const actionRejected = error => ({type: 'PROMISE', name, status: 'REJECTED', payload:null, error})


    return async dispatch => {
        dispatch(actionPending())
        try {
            let payload = await promise
            dispatch(actionResolved(payload))
        }
        catch (e){
            dispatch(actionRejected(e))
        }
    }
}

export const actionPosts = () => {
    return actionPromise('posts', gql.request(`query psts{
          getPosts{
            id, title, text    
          }
        }`))
}


export const actionLogin = (login,password) => {
    console.log(login, password)
    return actionPromise('posts', gql.request(`query login($login: String!, $password: String!){
          login(username: $login, password: $password)
        }`, {login, password}))
}
